<?php
/*****************************************************************************/
/* Display.php                                                               */
/*****************************************************************************/
/* YaBB SE: Yet another Bulletin Board Splinter Edition                      */
/* Open-Source Project inspired by Zef Hemel (zef@zefhemel.com)              */
/* Software Version:           YaBB SE 1.5.1                                 */
/* Software by:                The YaBB SE Development Team                  */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Copyright 2001-2003 by:     http://www.lewismedia.com (Lewis Media)       */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/* Inspired and Ported From:   http://www.yabbforum.com                      */
/*****************************************************************************/
/* This program is free software; you may redistribute it and/or modify it   */
/* under the terms of the provided license as published by Lewis Media.      */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the provided    */
/* license for more information.                                             */
/*                                                                           */
/* See license.txt for details of the YaBB SE license. The latest version    */
/* of this license can be found at the distributor's site seen above.        */
/*****************************************************************************/

$displayphpver= 'YaBB SE 1.5.1';

function Display()
{
	global $currentboard, $maxmessagedisplay, $censored, $enable_notification, $img;
	global $cgi, $yytitle, $imagesdir, $scripturl, $mbname, $showmodify, $settings;
	global $yyUDLoaded, $userprofile, $memberstar, $memberinfo, $icqad, $yimon, $ID_MEMBER;
	global $txt, $menusep, $start, $curposlinks, $color, $MenuType, $username;
	global $enable_ubbc, $profilebutton, $membergroups, $allow_hide_email, $threadid;
	global $moderators, $modSettings, $viewResults, $realNames, $db_prefix, $yySetLocation, $boardseen;
	global $sourcedir, $sc, $prev_next;

	if ($currentboard == '')
		fatal_error($txt[1]);
	if ($threadid == '')
		fatal_error($txt[472]);

	// If someone arrived here via a previous or next link, we must determine
	// the appropriate ID_TOPIC.  If no such topic exists, we must present
	// the user with an appropriate warning.
	if ($prev_next == 'prev' || $prev_next == 'next' )
	{
		// Just prepare some variables that are used in the query
		$gt_lt = ($prev_next == 'prev') ? '>' : '<';
		$order = ($prev_next == 'prev') ? 'ASC' : 'DESC';
		$error = ($prev_next == 'prev') ? $txt['a1'] : $txt['a2'];

		$query = "SELECT t2.ID_TOPIC FROM {$db_prefix}topics as t, {$db_prefix}topics as t2, {$db_prefix}messages as mes, {$db_prefix}messages as mes2
				WHERE (mes.ID_MSG=t.ID_LAST_MSG && t.ID_BOARD=$currentboard && t.ID_TOPIC=$threadid && ((mes2.posterTime $gt_lt mes.posterTime && t2.isSticky $gt_lt= t.isSticky) || t2.isSticky $gt_lt t.isSticky) && t2.ID_LAST_MSG=mes2.ID_MSG && t2.ID_BOARD=t.ID_BOARD)
				ORDER BY t2.isSticky $order, mes2.posterTime $order LIMIT 1";

		$request = mysql_query($query) or database_error(__FILE__, __LINE__);
		if (mysql_num_rows($request) > 0)
			list ($threadid) = mysql_fetch_row($request);
		elseif(mysql_num_rows($request) == 0) 
			fatal_error('You have reached the end of the topic list');
		
	}
	// at this point it is certain that $threadid holds the correct ID_TOPIC
	// for the topic the user wants to view
	$viewnum = $threadid;
	
	$result = mysql_query("SELECT b.ID_CAT,b.name,c.name,c.memberGroups FROM {$db_prefix}boards as b,{$db_prefix}categories as c WHERE (b.ID_BOARD=$currentboard && b.ID_CAT=c.ID_CAT)") or database_error(__FILE__, __LINE__);
	list($curcat,$boardname,$cat,$temp2) = mysql_fetch_row($result);
	$memgroups = explode(',',$temp2);

	if (!(in_array($settings[7],$memgroups) || $memgroups[0]==null || $settings[7]=='Administrator' || $settings[7]=='Global Moderator'))
		fatal_error($txt[1]);

	//Redirect to page & post with new messages -- Omar Bazavilvazo
	if ($start == 'new') 
	{
		// Check if a log exists, so we can go to next unreaded message page
		$request = mysql_query("
			SELECT GREATEST(IFNULL(lt.logTime, 0), IFNULL(lmr.logTime,0)) AS logtime, COUNT(m.ID_MSG), MAX(m.ID_MSG)
			FROM {$db_prefix}topics AS t
				LEFT JOIN {$db_prefix}log_topics AS lt ON (lt.ID_TOPIC=t.ID_TOPIC AND lt.ID_MEMBER=$ID_MEMBER)
				LEFT JOIN {$db_prefix}log_mark_read AS lmr ON (lmr.ID_BOARD=t.ID_BOARD AND lmr.ID_MEMBER=$ID_MEMBER)
				LEFT JOIN {$db_prefix}messages AS m ON (m.ID_TOPIC=t.ID_TOPIC)
			WHERE (t.ID_TOPIC = $viewnum)
			GROUP BY t.ID_TOPIC") or database_error(__FILE__, __LINE__);

		list($ltLastRead, $numMessages, $newestMessage) = mysql_fetch_row($request);

		$request = mysql_query("
			SELECT COUNT(*) 
			FROM {$db_prefix}messages 
			WHERE ID_TOPIC = $viewnum 
				AND posterTime <= $ltLastRead") or database_error(__FILE__, __LINE__);
				
		list($numReadMessages) = mysql_fetch_row($request);
		$numUnreadMessages = $numMessages - $numReadMessages;

		if ($modSettings['viewNewestFirst'] == '1')
			$Page2Show = floor(($numUnreadMessages == 0 ? 0 : $numUnreadMessages - 1) / $maxmessagedisplay) * $maxmessagedisplay;
		else
			$Page2Show = floor(($numReadMessages  == $numMessages ? $numReadMessages - 1 : $numReadMessages) / $maxmessagedisplay) * $maxmessagedisplay;

		if ($numUnreadMessages > 0) 
		{
			$request = mysql_query("
				SELECT MIN(ID_MSG)
				FROM {$db_prefix}messages 
				WHERE ID_TOPIC = $viewnum 
					AND posterTime > $ltLastRead") or database_error(__FILE__, __LINE__);
			list($firstUnreadMessage) = mysql_fetch_row($request);
			$newMsgID = "#msg$firstUnreadMessage";
		}
		elseif ($modSettings['viewNewestFirst'] == '1')
			$newMsgID = "#msg$newestMessage"; 
		else
			$newMsgID = '#lastPost';

		// mark board as seen if we came using notification
		$request = mysql_query("
			REPLACE INTO {$db_prefix}log_boards (logTime, ID_MEMBER, ID_BOARD) 
			VALUES (" . time() . ", $ID_MEMBER, $currentboard)") or database_error(__FILE__, __LINE__);
		$yySetLocation = $cgi . ';action=display;threadid=' . $viewnum . ';start=' . $Page2Show . $newMsgID;
		redirectexit();
	}
	elseif (substr($start, 0, 3) == 'msg')
	{
		$msg = (int) substr($start, 3);
		$request = mysql_query("SELECT COUNT(*) FROM {$db_prefix}messages WHERE (ID_MSG < $msg && ID_TOPIC=$threadid)") or database_error(__FILE__, __LINE__);
		list($start) = mysql_fetch_row($request);
	}


	// do the previous next stuff
	// Create a previous next string if the selected theme has it 
	// as a selected option
	$previousNext = $modSettings['enablePreviousNext'] ? "<a href=\"$cgi;action=display;threadid=$threadid;prev_next=prev\">$modSettings[PreviousNext_back]</a> <a href=\"$cgi;action=display;threadid=$threadid;prev_next=next\">$modSettings[PreviousNext_forward]</a>" : '';

	$request = mysql_query("
		SELECT membergroup
		FROM {$db_prefix}membergroups
		ORDER BY ID_GROUP") or database_error(__FILE__, __LINE__);
				
	$membergroups = array();

	while ($row = mysql_fetch_row($request))
		$membergroups[] = $row[0];

	// get all the topic info
	$request = mysql_query("
		SELECT t.numReplies, t.numViews, t.locked, ms.subject, t.isSticky, ms.posterName, ms.ID_MEMBER, t.ID_POLL, t.ID_MEMBER_STARTED
		FROM {$db_prefix}topics as t, {$db_prefix}messages as ms
		WHERE t.ID_BOARD = $currentboard
			AND t.ID_TOPIC = $viewnum
			AND ms.ID_MSG = t.ID_FIRST_MSG") or database_error(__FILE__, __LINE__);
				
	if (mysql_num_rows($request) == 0)
		fatal_error($txt[472]);
		
	$topicinfo = mysql_fetch_assoc($request);

	// mark the topic as read :)
	$request = mysql_query("
		REPLACE INTO {$db_prefix}log_topics (logTime, ID_MEMBER, ID_TOPIC, notificationSent)
		VALUES (" . time() . ", $ID_MEMBER, $viewnum,0)") or database_error(__FILE__, __LINE__);

	// mark board as seen if we came using last post link from BoardIndex
	if (isset($boardseen)) 
		$request = mysql_query("
			REPLACE INTO {$db_prefix}log_boards (logTime, ID_MEMBER, ID_BOARD)
			VALUES (" . time() . ", $ID_MEMBER, $currentboard)") or database_error(__FILE__, __LINE__);

	// Add 1 to the number of views of this thread.
	$request = mysql_query("
		UPDATE {$db_prefix}topics
		SET numViews = numViews + 1
		WHERE ID_TOPIC = $viewnum") or database_error(__FILE__, __LINE__);

	/*# Check to make sure this thread isn't locked. */
	$noposting = $topicinfo['locked'];
	$mreplies = $topicinfo['numReplies'];
	$mstate = $topicinfo['locked'];
	$msubthread = $topicinfo['subject'];
	$yytitle = str_replace("\$", "&#36;", $topicinfo['subject']);

	# Get the class of this thread, based on lock status and number of replies.
	$threadclass = '';
	if ($mstate == 1 || $mstate == 2)
		$threadclass = 'locked';
	elseif ($mreplies > 24) 
		$threadclass = 'veryhotthread';
	elseif ($mreplies > 14)
		$threadclass = 'hotthread';
	elseif ($mstate == 0)
		$threadclass = 'thread';
		
	if ($modSettings['enableStickyTopics'] == 1 && $topicinfo['isSticky'] == 1)
		$threadclass = 'sticky';
		
	if (($mstate == 1 || $mstate == 2) && ($modSettings['enableStickyTopics'] == 1 && $topicinfo['isSticky'] == '1'))
		$threadclass='lockedsticky';

	CensorTxt($msubthread);
	CensorTxt($yytitle);

	// Build a list of this board's moderators.
	$showmods = '';		// create an empty string
	$tmp = array();		// used to temporarily store the list
	$moderatorusernames = array();
	
	// moderators is defined near the start of the function
	if (sizeof($moderators) > 0 && $moderators[0] != NULL) 
	{
		if (sizeof($moderators) == 1)		// if only one mod - use a different string
			$showmods = "($txt[298]: ";
		else
			$showmods = "($txt[299]: ";
			
		for ($i = 0; $i < sizeof($moderators); $i++)
		{
			$euser = urlencode($moderators[$i]);
			$tmp[$i] = '<a href="' . $scripturl . '?action=viewprofile;user=' . $euser . '"><acronym title="' . $txt[62] . '">' . $realNames[$moderators[$i]] . '</acronym></a>';
			$moderatorusernames[trim($moderators[$i])] = true;
		}
		
		$showmods .= implode(", ", $tmp) . ')';	// stitch the list together
	}

	$selecthtml = jumpto();

	// Build the page links list.
	$max = $mreplies + 1;
	$start = (($start > $mreplies) ? $mreplies : $start);
	$start = (floor($start / $maxmessagedisplay)) * $maxmessagedisplay;

	if ($modSettings['compactTopicPagesEnable'] == 0) 
	{
		$tmpa = $start - $maxmessagedisplay;
		$pageindex = (($start == 0) ? '' : '<a href="' . $cgi . ';action=display;threadid=' . $viewnum . ';start=' . $tmpa . '">&#171;</a>');
		$tmpa = 1;
		for ($counter = 0; $counter < $max; $counter += $maxmessagedisplay)
		{
			$pageindex .= (($start == $counter) ? ' <b>' . $tmpa . '</b>' : ' <a href="' . $cgi . ';action=display;threadid=' . $viewnum . ';start=' . $counter . '">' . $tmpa . '</a>');
			$tmpa++;
		}
		$tmpa = $start + $maxmessagedisplay;
		$tmpa = ($tmpa > $mreplies ? $mreplies : $tmpa);
		if ($start != $counter-$maxmessagedisplay) 
			$pageindex .= (($tmpa > $counter - $maxmessagedisplay) ? ' ' : ' <a href="' . $cgi . ';action=display;threadid=' . $viewnum . ';start=' . $tmpa . '">&#187;</a> ');
	}
	else 
	{
		if (($modSettings['compactTopicPagesContiguous'] % 2) == 1)	//1,3,5,...
			$PageContiguous = (int)(($modSettings['compactTopicPagesContiguous'] - 1) / 2);
		else
			$PageContiguous = (int)($modSettings['compactTopicPagesContiguous'] / 2);	//invalid value, but let's deal with it

		if ($start > $maxmessagedisplay * $PageContiguous)	//	first
			$pageindex.= '<a class="navPages" href="' . $cgi . ';action=display;threadid=' . $viewnum . '">1</a> ';

		if ($start > $maxmessagedisplay * ($PageContiguous + 1))	// ...
			$pageindex.= '<b> ... </b>';

		for ($nCont=$PageContiguous; $nCont >= 1; $nCont--)	// 1 & 2 before
			if ($start >= $maxmessagedisplay * $nCont) 
			{
				$tmpStart = $start - $maxmessagedisplay * $nCont;
				$tmpPage = $tmpStart / $maxmessagedisplay + 1;
				$pageindex .= '<a class="navPages" href="' . $cgi . ';action=display;threadid=' . $viewnum . ';start=' . $tmpStart . '">' . $tmpPage . '</a> ';
			}

		$tmpPage = $start / $maxmessagedisplay + 1;	// page to show
		$pageindex .= ' [<b>' . $tmpPage . '</b>] ';

		$tmpMaxPages = (int)(($max - 1) / $maxmessagedisplay) * $maxmessagedisplay;	// 1 & 2 after
		for ($nCont=1; $nCont <= $PageContiguous; $nCont++)
			if ($start + $maxmessagedisplay * $nCont <= $tmpMaxPages) 
			{
				$tmpStart = $start + $maxmessagedisplay * $nCont;
				$tmpPage = $tmpStart / $maxmessagedisplay + 1;
				$pageindex .= '<a class="navPages" href="' . $cgi . ';action=display;threadid=' . $viewnum . ';start=' . $tmpStart . '">' . $tmpPage . '</a> ';
			}

		if ($start + $maxmessagedisplay * ($PageContiguous + 1) < $tmpMaxPages)	// ...
			$pageindex .= '<b> ... </b>';

		if ($start + $maxmessagedisplay * $PageContiguous < $tmpMaxPages)	//	last
		{ 
			$tmpPage = $tmpMaxPages / $maxmessagedisplay + 1;
			$pageindex .= '<a class="navPages" href="' . $cgi . ';action=display;threadid=' . $viewnum . ';start=' . $tmpMaxPages . '">' . $tmpPage . '</a> ';
		}
	}

	$curthreadurl = ($curposlinks ? '<a href="' . $cgi . ';action=display;threadid=' . $viewnum . '" class="nav">' . $msubthread . '</a>' : $msubthread);

	# Build the link tree
	$displayLinkTree = ($modSettings['enableInlineLinks'] ? '<font size="1" class="nav"><b><a href="' . $scripturl . '" class="nav">' . $mbname . '</a> </b>&nbsp;|&nbsp;<b> ' : '<font size="2" class="nav"><b><img src="' . $imagesdir . '/open.gif" border="0" alt="" />&nbsp;&nbsp;<a href="' . $scripturl . '" class="nav">' . $mbname . '</a><br />' );
	$displayLinkTree .= ($modSettings['enableInlineLinks'] ? '<a href="' . $scripturl . '#' . $curcat . '" class="nav">' . $cat . '</a> </b>&nbsp;|&nbsp;<b> ' : '<img src="' . $imagesdir . '/tline.gif" border="0" alt="" /><img src="' . $imagesdir . '/open.gif" border="0" alt="" />&nbsp;&nbsp;<a href="' . $scripturl . '#' . $curcat . '" class="nav">' . $cat . '</a><br />');
	$displayLinkTree .= ($modSettings['enableInlineLinks'] ? '<a href="' . $cgi . '" class="nav">' . $boardname . '</a></b> ' . $showmods . '<b> </b>&nbsp;|&nbsp;<b> ' : '<img src="' . $imagesdir . '/tline2.gif" border="0" alt="" /><img src="' . $imagesdir . '/open.gif" border="0" alt="" />&nbsp;&nbsp;<a href="' . $cgi . '" class="nav">' . $boardname . '</a></b> ' . $showmods . '<b><br />');
	$displayLinkTree .= ($modSettings['enableInlineLinks'] ? $txt[118] . ':&nbsp;' . $curthreadurl . '</b></font>' : '<img src="' . $imagesdir . '/tline3.gif" border="0" alt="" /><img src="' . $imagesdir . '/open.gif" border="0" alt="" />&nbsp;&nbsp;' . $curthreadurl . '</b></font>');
	$bottomLinkTree = ($modSettings['enableInlineLinks'] ? '<td valign="top" align="left">' . $displayLinkTree . '</td> ' : '');
	
	if ($modSettings['topbottomEnable'] != '0')
	{ 
		$botlink = $menusep . '<a href="#bot">' . $img['tbbottom'] . '</a>';
		$toplink = $menusep . '<a href="#top">' . $img['tbtop'] . '</a>';
	}
	else 
	{ 
		$botlink=''; 
		$toplink=''; 
	}


	// Compose topic button bar
	$topicButtons = array();

	if (!$mstate || $settings[7] == 'Administrator' || $settings[7] == 'Global Moderator' || in_array($username,$moderators))
		$topicButtons[] = '<a href="' . $cgi . ';action=post;threadid=' . $viewnum . ';title=' . URLencode($txt[116]) . ';start=' . $start . '">' . $img['reply'] . '</a>';

	if ($enable_notification) // $enable_notification is defined in settings
		$topicButtons[] = '<a href="' . $cgi . ';action=notify;threadid=' . $viewnum . ';start=' . $start . '">' . $img['notify'] . '</a>';

	$topicButtons[] = '<a href="' . $cgi . ';action=sendtopic;threadid=' . $viewnum . '">' . $img['sendtopic'] . '</a>';

	$topicButtons[] = '<a href="' . $cgi . ';action=printpage;threadid=' . $viewnum . '" target="_blank">' . $img['printt'] . '</a>';



	// Compose moderation button bar
	$moderationButtons = array();

	if (in_array($username, $moderators) || $settings[7] == 'Administrator' || $settings[7] == 'Global Moderator') 
	{
		$moderationButtons[] = '<a href="' . $cgi . ';action=movethread;threadid=' . $viewnum . '">' . $img['movethread'] . '</a>';
		$moderationButtons[] = '<a href="javascript:DoConfirm(\'' . $txt[162] . '\',\'' . $cgi . ';action=removethread2;threadid=' . $viewnum . ';sesc=' . $sc . '\');">' . $img['removethread'] . '</a>';
	}

	$topicinfo['locked'] = ($topicinfo['locked'] == 2 ? 1 : $topicinfo['locked']); //topics locked by a user should get the same icon as topics locked by a moderator.

	if (in_array($username, $moderators) || $settings[7] == 'Administrator' || $settings[7] == 'Global Moderator' || ($username == $topicinfo['posterName'] && $username != 'Guest' && $modSettings['enableUserTopicLocking'] == 1))
		$moderationButtons[] = '<a href="' . $cgi . ';action=lock;threadid=' . $viewnum . ';sesc=' . $sc . '">'. $img["lockthread$topicinfo[locked]"] . '</a>';

	if ($modSettings['enableStickyTopics'] == 1 && (in_array($username, $moderators) || $settings[7] == 'Administrator' || $settings[7] == 'Global Moderator')) 
		$moderationButtons[] = '<a href="' . $cgi . ';action=sticky;threadid=' . $viewnum . ';sticky=' . $topicinfo['isSticky'] . ';sesc=' . $sc . '">' . $img["sticky$topicinfo[isSticky]"] . '</a>';

	if (in_array($username, $moderators) || $settings[7] == 'Administrator' || $settings[7] == 'Global Moderator')
		$moderationButtons[] = '<a href="' . $cgi . ';action=mergethreads;from=' . $viewnum . '">' . $img['merge_display'] . '</a>';

	if ($modSettings['cal_enabled'] == '1' && (in_array($username, $moderators) || $settings[7] == 'Administrator' || $settings[7] == 'Global Moderator' || ($username == "$topicinfo[posterName]" && $username != 'Guest')))
	{
		include_once "$sourcedir/Calendar.php";
		if (CalendarCanPost())
			$moderationButtons[] = '<a href="' . $cgi . ';action=calendarle;threadid=' . $viewnum . ';board=' . $currentboard . '">' . $img['linkToCalendar'] . '</a>';
	}


	// Create the poll info if it exists
	$pollHtml = '';
	if ($topicinfo['ID_POLL'] != '-1' && $modSettings['pollMode'] == 1)
	{
		$request = mysql_query("
			SELECT question, votingLocked, votedMemberIDs, option1, option2, option3, option4, option5, option6, option7, option8, votes1, votes2, votes3, votes4, votes5, votes6, votes7, votes8
			FROM {$db_prefix}polls
			WHERE ID_POLL = '$topicinfo[ID_POLL]'
			LIMIT 1") or database_error(__FILE__, __LINE__);
					
		$pollinfo = mysql_fetch_assoc($request);
		$pollimage=($pollinfo['votingLocked'] != '0' )?'locked_poll':'poll';
		$pollHtml = '
			<table cellpadding="0" cellspacing="0" border="0" width="100%" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" align="center">
				<tr>
					<td>
						<table cellpadding="3" cellspacing="0" width="100%">
							<tr>
								<td valign="middle" align="left" bgcolor="' . $color['titlebg'] . '" class="titlebg">
									<font size="2" class="text1" color="' . $color['titletext'] . '">&nbsp;<img src="' . $imagesdir . '/' . $pollimage . '.gif" alt="" /> <b>' . $txt['yse43'] . '</b></font>
								</td>
							</tr>
						</table>
						<table cellpadding="3" cellspacing="1" border="0" width="100%">
							<tr>
								<td valign="middle" align="left" bgcolor="' . $color['windowbg'] . '" class="windowbg">
									<table border="0">
										<tr>
											<td valign="top"><b>' . $txt['yse21'] . ':</b></td>
											<td>
												' . DoUBBC($pollinfo['question']);
		$lockVoting = '';
		$pollEdit = '';

		if ($ID_MEMBER == $topicinfo['ID_MEMBER_STARTED'] || in_array($username, $moderators) || $settings[7] == 'Administrator')
			$lockVoting = '<br /><a href="' . $cgi . ';action=lockVoting;start=' . $start . ';threadid=' . $threadid . ';sesc=' . $sc . '">' . ($pollinfo['votingLocked']== '0' ? $txt['yse30'] : $txt['yse30b']) . '</a>';
		
		if (($ID_MEMBER == $topicinfo['ID_MEMBER_STARTED'] && $modSettings['pollEditMode'] == '2') || (in_array($username, $moderators) && in_array($modSettings['pollEditMode'], array('2', '1'))) || $settings[7] == 'Administrator')
			$pollEdit = '<a href="' . $cgi . ';action=editpoll;start=' . $start . ';threadid=' . $threadid . '">' . $txt['yse39'] . '</a>';
		
		if ($ID_MEMBER == '-1' || in_array("$ID_MEMBER", explode(',', $pollinfo['votedMemberIDs'])) || $pollinfo['votingLocked'] != '0' || $viewResults == '1')
		{
			$totalvotes = $pollinfo['votes1'] + $pollinfo['votes2'] + $pollinfo['votes3'] + $pollinfo['votes4'] + $pollinfo['votes5'] + $pollinfo['votes6'] + $pollinfo['votes7'] + $pollinfo['votes8'];
			$divisor = (($totalvotes == 0) ? 1 : $totalvotes);
			$pollHtml .= '
												<table>
													<tr>
														<td><br />
															<table border="0" cellpadding="0" cellspacing="0">';
			for ($i = 1; $i <= 8; $i++)
				if ($pollinfo["option$i"] != '')
				{
					$bar = floor(($pollinfo["votes$i"] / $divisor) * 100);
					$barWide = (($bar == 0) ? 1 : floor(($bar * 5) / 3));
					$barLine = '<img src="' . $imagesdir . '/poll_left.gif" alt="" /><img src="' . $imagesdir . '/poll_middle.gif" width="' . $barWide . '" height="12" alt="" /><img src="' . $imagesdir . '/poll_right.gif" alt="" />';
					$pollHtml .= '
																<tr>
																	<td>' . DoUBBC($pollinfo["option$i"]) . '</td>
																	<td width="7">&nbsp;</td>
																	<td nowrap="nowrap">' . $barLine . $pollinfo["votes$i"] . ' (' . $bar . '%)</td>
																</tr>';
				}
			$pollHtml .= '
															</table>
														</td>
														<td width="15">&nbsp;</td>
														<td valign="bottom">' . $lockVoting . '&nbsp;&nbsp;' . $pollEdit . '</td>
													</tr><tr>
														<td><b>' . $txt['yse24'] . ': ' . $totalvotes . '</b></td>
														<td>&nbsp;</td>
													</tr>
												</table><br />';
		}
		else
		{
			$pollHtml .= '
												<form action="' . $cgi . ';action=vote;threadid=' . $threadid . ';start=' . $start . ';poll=' . $topicinfo['ID_POLL'] . '" method="post">
													<table>
														<tr>
															<td>';
			for ($i = 1; $i <= 8; $i++)
				if ($pollinfo["option$i"] != '')
					$pollHtml .= '<input type="radio" name="option" value="' . $i . '" /> ' . DoUBBC($pollinfo["option$i"]) . '<br />' . "\n";
			
			$pollHtml .= '
															</td>
															<td width="15">&nbsp;</td>
															<td valign="bottom">
																<a href="' . $cgi . ';action=display;start=' . $start . ';threadid=' . $threadid . ';viewResults=1">' . $txt['yse29'] . '</a>' . $lockVoting . '&nbsp;&nbsp;' . $pollEdit . '
															</td>
														</tr><tr>
															<td><input type="submit" value="' . $txt['yse23'] . '" /></td>
															<td>&nbsp;</td>
														</tr>
													</table>
													<input type="hidden" name="sc" value="' . $sc . '" />
												</form>';
		}

		$pollHtml .= '
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>';
	}

	template_header();
	
	echo '
		<script language="JavaScript1.2" type="text/javascript"><!--
			function DoConfirm(message, url) 
			{
				if (confirm(message))
					location.href = url;
			}
		//--></script>
		<table width="100%" cellpadding="0" cellspacing="0">
			<tr>
				<td valign="bottom"><a name="top"></a>' . $displayLinkTree . '</td>
				<td valign="bottom" align="right">
					<font size="1" class="nav">' . $previousNext . '</font>
				</td>
			</tr>
		</table>
		<table border="0" width="100%" cellspacing="0" cellpadding="0" bgcolor="' . $color['bordercolor'] . '" class="bordercolor"><tr><td>
			<table width="100%" cellpadding="3" cellspacing="1" border="0" bgcolor="' . $color['bordercolor'] . '" class="bordercolor">
				<tr>
					<td align="left" class="catbg" bgcolor="' . $color['catbg'] . '" width="100%"  height="35">
						<table cellpadding="3" cellspacing="0" width="100%">
							<tr>
								<td>
									<font size="2"><b>' . $txt[139] . ':</b> ' . $pageindex . '</font>' . $botlink . '
								</td>
								<td align="right"><font size="-1">' . implode($menusep, $topicButtons) . '</font></td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td></tr></table>
		' . $pollHtml . '
		<table cellpadding="0" cellspacing="0" border="0" width="100%" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" align="center">
			<tr>
				<td>
					<table cellpadding="3" cellspacing="1" border="0" width="100%">
						<tr>
							<td valign="middle" align="left" width="15%" bgcolor="' . $color['titlebg'] . '" class="titlebg">
								<font size="2" class="text1" color="' . $color['titletext'] . '">&nbsp;<img src="' . $imagesdir . '/' . $threadclass . '.gif" alt="" />
								&nbsp;<b>' . $txt[29] . '</b></font>
							</td>
							<td valign="middle" align="left" bgcolor="' . $color['titlebg'] . '" class="titlebg" width="85%">
								<font size="2" class="text1" color="' . $color['titletext'] . '"><b>&nbsp;' . $txt[118] . ': ' . $msubthread . '</b> &nbsp;(' . $txt[641]. ' ' . $topicinfo['numViews'] . ' ' . $txt[642] . ')</font>
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>';


	# Load background color list.
	$bgcolors = array($color['windowbg'], $color['windowbg2']);
	$bgcolornum = sizeof($bgcolors);
	$cssvalues = array('windowbg', 'windowbg2');
	$cssimgvalues = array('','_bg2');
	$cssnum = sizeof($bgcolors);

	if ($MenuType == 0)
		$sm = 1;
	 
	$counter = $start;

	# For each post in this thread
	$request = mysql_query("
		SELECT ID_MSG
		FROM {$db_prefix}messages
		WHERE ID_TOPIC=$viewnum
		ORDER BY ID_MSG " . ($modSettings['viewNewestFirst'] == 1 ? 'DESC' : '') . "
		LIMIT $start,$maxmessagedisplay") or database_error(__FILE__, __LINE__);
				
	$messages = array();
	while ($row = mysql_fetch_assoc($request))
		$messages[] = $row['ID_MSG'];
	
	if (count($messages))
		$request = mysql_query("
			SELECT m.ID_MSG, m.subject, m.posterName, m.posterEmail, m.posterTime, m.ID_MEMBER, m.icon, m.posterIP, m.body, m.smiliesEnabled, m.modifiedTime, m.modifiedName, m.attachmentFilename, m.attachmentSize, IFNULL(mem.realName, m.posterName) AS posterDisplayName, IFNULL(lo.logTime, 0) AS isOnline
			FROM {$db_prefix}messages AS m
				LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER=m.ID_MEMBER)
				LEFT JOIN {$db_prefix}log_online AS lo ON (lo.identity=mem.ID_MEMBER)
			WHERE m.ID_MSG IN (" . implode(',', $messages) . ")
			ORDER BY ID_MSG " . ($modSettings['viewNewestFirst'] == 1 ? 'DESC' : '')) or database_error(__FILE__, __LINE__);

	echo '<table cellpadding="0" cellspacing="0" border="0" width="100%" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" align="center">';

	while ($message = mysql_fetch_array($request)) 
	{
		# Set up the attachment info - Meriadoc 12/14/2001
		$attached = '';
		if ($message['attachmentSize'] > 0 && $modSettings['attachmentEnable'] != 0)
			$attached = '<a href="' . $modSettings['attachmentUrl'] . '/' . $message['attachmentFilename'] . '" target="_blank"><img src="' . $imagesdir . '/clip.gif" align="middle" border="0" />&nbsp;<font size="1">' . $message['attachmentFilename'] . '</font></a><br />';

		// Set up the image attachment info
		$attachImage = '';
		if ($modSettings['attachmentShowImages'] == 1 && $modSettings['attachmentEnable'] != 0)
		{
			$imageTypes = array('jpg', 'jpeg', 'gif', 'png');
			if (in_array(strtolower(substr(strrchr($message['attachmentFilename'], '.'), 1)), $imageTypes))
			{
				//start resize/restrict posted images mod by Mostmaster
				$maxwidth = $modSettings['maxwidth'];
				$maxheight = $modSettings['maxheight'];
				$imagesize = @getimagesize("$modSettings[attachmentUrl]/$message[attachmentFilename]");
				$width = $imagesize[0];
				$height = $imagesize[1];
				if (!($maxwidth == '0' && $maxheight == 0) && ($width > $maxwidth || $height > $maxheight))
				{
					if ($width > $maxwidth && $maxwidth != 0)
					{
						$height = floor($maxwidth / $width * $height);
						$width = $maxwidth;
						if ($height > $maxheight && $maxheight != 0)
						{
							$width = floor($maxheight / $height * $width);
							$height = $maxheight;
						}
					}
					elseif ($height > $maxheight && $maxheight != 0)
					{
						$width = floor($maxheight / $height * $width);
						$height = $maxheight;
					}
					$attachImage = '<hr color=gray size="1" /><img src="' . $modSettings['attachmentUrl'] . '/' . $message['attachmentFilename'] . '" width="' . $width . '" height="' . $height . '" />';
				}
				else
					$attachImage = '<hr color=gray size="1" /><img src="' . $modSettings['attachmentUrl'] . '/' . $message['attachmentFilename'] . '" />';
				
				//end resize/restrict posted images mod by Mostmaster
			}
		}

		list ($mid, $msub, $mname, $memail, $mdate, $muserID, $micon, $mip, $postmessage, $es, $mlm, $mlmb) = $message;

		$windowbg = $bgcolors[($counter % $bgcolornum)];
		$css = $cssvalues[($counter % $cssnum)];
		$cssimg = $cssimgvalues[($counter % $cssnum)];

		# Should we show "last modified by?"
		$lastmodified = '';
		if ($mlm && $showmodify && !empty($mlm) && !empty($mlmb)) 
		{
			$messed = timeformat($mlm);
			$lastmodified = '&#171; <i>' . $txt[211] . ': ' . $messed . ' ' . $txt[525] . ' ' . $mlmb . '</i> &#187;';
		}
		
		$msub = (isset($msub) ? $msub:$txt[24]);
		$messdate = timeformat($mdate);
		$mip = ($settings[7] == 'Administrator' ? $mip : $txt[511]);

		# If the user isn't a guest, load his/her info.
		$set = false;
		if ($muserID != -1 && !isset($yyUDLoaded[$mname])) 
		{
			# If user is not in memory, s/he must be loaded.
			$realNames[$message['postername']] = $message['posterDisplayName'];
			$set = LoadUserDisplay($mname);
		}

		$online = '';
		$title = '';
		$star = '';
		$icq = '';
		$yim = '';
		$memberinf ='';
		$postinfo = '';
		$usernamelink = '';
		if (isset($yyUDLoaded[$mname]) && $muserID != '-1') 
		{
			$star = $memberstar[$mname];
			$addfunction = '';
			$rlnm = $userprofile[$mname]['realName'];
			$psts = $userprofile[$mname]['posts'];
			if ($modSettings['titlesEnable'] != '0' && $userprofile[$mname]['usertitle'] != '')
				$title = $userprofile[$mname]['usertitle'] . '<br />';
			
			$userisonline = $message['isOnline'];
			if ($modSettings['onlineEnable'] != '0') 
			{
				if ($message['isOnline'] > 0)
					$online = '<a href="' . $cgi . ';action=imsend;to=' . urlencode($mname) . '">' . $txt['online2'] . '<br /><br />' . "\n"; 
				else 
					$online = '<a href="' . $cgi . ';action=imsend;to=' . urlencode($mname) . '">' . $txt['online3'] . '<br /><br />' . "\n";
			}
			else 
				$online = '';
				
			$memberinf = $memberinf.$memberinfo[$mname];
			$icq = $icqad[$mname];
			$yim = $yimon[$mname];
			$msn = $userprofile[$mname]['MSN'];

					
			$euser = urlencode($mname);
			$usernamelink = '<a href="' . $scripturl . '?board=' . $currentboard . ';action=viewprofile;user=' . $euser . '"><font size="2"><b><acronym title="' . $txt[92] . ' ' . $rlnm . '">' . $rlnm . '</acronym></b></font></a>';
			$postinfo = $txt[26] . ': ' . $psts . '<br />';
			$memail = $userprofile[$mname]['emailAddress'];
		}
		else 
		{
			$musername = 'Guest';
			$memberinf = "$txt[28]";
			$usernamelink = '<font size="2"><b>' . $mname . '</b></font>';
		}

		CensorTxt($postmessage);
		CensorTxt($msub);

		# Run UBBC interpreter on the message.
		$message = $postmessage; # put the message back into the proper variable to do ubbc on it
		if ($enable_ubbc)
			$message = DoUBBC($message, $es);
			
		$counterwords = '';
		if ($counter != 0)
			$counterwords = "$txt[146] #$counter";

		//compose the profile button bar
		$profileButtons = array();
		if ($profilebutton)
		{
			if ($muserID != '-1')
			{
				$euser = urlencode($mname);
				$profileButtons[] = '<a href="' . $scripturl . '?action=viewprofile;user=' . $euser . '">' . $img['viewprofile_sm'] . '</a>';
			}
			
			if (strlen($userprofile[$mname]['websiteUrl']))
				$profileButtons[] = $userprofile[$mname]['websiteUrl'];
	
			if ($userprofile[$mname]['hideEmail'] != '1' || $settings[7] == 'Administrator' || $allow_hide_email != '1') 
				$profileButtons[] = "<a href=\"mailto:$memail\">$img[email_sm]</a>";

			if ($username != 'Guest')
				$profileButtons[] = '<a href="' . $cgi . ';action=imsend;to=' . $mname . '">'. $img['message_sm_' . ($userisonline > 0 ? 'on' : 'off')] . '</a>';
		}

		$userinfo = 
					$usernamelink . '<br />
					<font size="1">
						' . $title . '
						' . $memberinf . '<br />';

		if ($muserID != '-1') 
		{
			$userinfo .= '
						' . $star . '<br /><br />
						' . $online . '
						' . $userprofile[$mname]['gender'] . '
						' . $postinfo . '
						' . $userprofile[$mname]['avatar'] . '
						' . $userprofile[$mname]['personalText'] . '
						' . $userprofile[$mname]['ICQ'] . ' ' . $icq. ' ' . $msn . ' ' . $yim . ' ' . $userprofile[$mname]['AIM'] . '<br />
						' . implode($menusep, $profileButtons);
		}
		else
			$userinfo .= '<br /><a href="mailto:' . $memail . '">' . $img['email_sm'] . '</a>' . "\n";
		$userinfo .= '
					</font>';

		$messageButtons = array();
		if (!$mstate || $settings[7] == 'Administrator' || $settings[7] == 'Global Moderator' || in_array($username,$moderators))
		{
			$messageButtons[] = '<a href="' . $cgi . ';action=post;threadid=' . $viewnum . ';quote=' . $mid . ';title=' . URLencode($txt[116]) . ';start=' . $start . ';sesc=' . $sc . '">' . $img["replyquote{$cssimg}"] . '</a>';
			if (in_array($username, $moderators) || $settings[7] == 'Administrator' || $settings[7] == 'Global Moderator' || ($ID_MEMBER == $muserID && $ID_MEMBER != -1))
			{
				$messageButtons[] = '<a href="' . $cgi . ';action=modify;msg=' . $mid . ';threadid=' . $viewnum . ';start=' . $start . ';sesc=' . $sc . '">' . $img["modify{$cssimg}"] . '</a>';
				$messageButtons[] = '<a href="javascript:DoConfirm(\'' . $txt[154] . "?','" . $cgi . ';action=modify2;threadid=' . $viewnum . ';msg=' . $mid . ';d=1;start=' . $start . ';sesc=' . $sc . '\');">' . $img["delete{$cssimg}"] . '</a>';
			}
			if (in_array($username, $moderators) || $settings[7] == 'Administrator' || $settings[7] == 'Global Moderator')
				$messageButtons[] = '<a href="' . $cgi . ';action=splitthreads;thread=' . $viewnum . ';at=' . $mid . '">' . $img["split{$cssimg}"] . '</a>';
		}

		if ($modSettings['enableReportToMod'] == '1')
			$reportToModerator = '<font size="1"><a href="' . $cgi . ';action=reporttm;thread=' . $viewnum . ';id=' . $counter . ';subject=' . htmlentities(urlencode(un_html_entities($msub))) . ';poster=' . $mname . ';msgid=' . $mid . '">' . $txt['rtm1'] . '</a></font>&nbsp;&nbsp;';
		else
			$reportToModerator = '';

		if ($mip == $txt[511])
			$ipInfo = '<img src="' . $imagesdir . '/ip.gif" alt="" border="0" /> ' . $mip;
		else
			$ipInfo = '<a href="http://www.nic.com/cgi-bin/whois.cgi?query=' . $mip . '" target="_blank"><img src="' . $imagesdir . '/ip.gif" alt="" border="0" /> ' . $mip . '</a>';

		$signature = ($muserID != '-1' ?$signature =  $userprofile[$mname]['signature'] : '');


		# Print the post and user info for the poster.
		echo '
			<tr>
				<td>
					<a name="msg' . $mid . '"></a>
					<table cellpadding="3" cellspacing="1" border="0" width="100%">
						<tr>
							<td bgcolor="' . $windowbg . '" class="' . $css . '">
								<table width="100%" cellpadding="4" cellspacing="1" class="' . $css . '" bgcolor="' . $windowbg . '">
									<tr>
										<td class="' . $css . '" bgcolor="' . $windowbg . '" valign="top" width="15%" rowspan="2">
											' . $userinfo . '
										</td>
										<td class="' . $css . '" bgcolor="' . $windowbg . '" valign="top" width="85%" height="100%">
											<table width="100%" border="0">
												<tr>
													<td align="left" valign="middle"><img src="' . $imagesdir . '/' . $micon . '.gif" alt="" /></td>
													<td align="left" valign="middle">
														<font size="2"><b>' . $msub . '</b></font><br />
														<font size="1">&#171; <b>' . $counterwords . ' ' . $txt[30] . ':</b> ' . $messdate . ' &#187;</font>
													</td>
													<td align="right" valign="bottom" height="20" nowrap="nowrap">
														<font size="-1">' . implode($menusep, $messageButtons) . '</font>
													</td>
												</tr>
											</table>
											<hr width="100%" size="1" class="windowbg3" />
											' . $message . '
										</td>
									</tr><tr>
										<td class="' . $css . '" bgcolor="' . $windowbg . '" valign="bottom">
											<table width="100%" border="0">
												<tr>
													<td align="left"><font size="1">' . $attached . $lastmodified . '</font></td>
													<td align="right">
														<font size="1">
															' . $reportToModerator . '
															' . $ipInfo . '
														</font>
													</td>
												</tr>
											</table>
											' . $signature . '
											' . $attachImage . '
										</td>
									</tr>
								</table>
							</td>
						</tr>
					</table>
				</td>
			</tr>';

		$counter++;
	}

	echo '
		</table>
		<a name="lastPost"></a>
		<table border="0" width="100%" cellspacing="0" cellpadding="0" bgcolor="' . $color['bordercolor'] . '" class="bordercolor"><tr><td>
			<table width="100%" border="0" cellpadding="3" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor">
				<tr>
					<td align="left" class="catbg" bgcolor="' . $color['catbg'] . '" width="100%" height="30">
						<table cellpadding="3" cellspacing="0" width="100%">
							<tr>
								<td>
									<font size="2"><a name="bot"></a><b>' . $txt[139] . ':</b> ' . $pageindex . '</font>' . $toplink . '
								</td>
								<td align="right">
									<font size="-1">' . implode($menusep, $topicButtons) . '&nbsp;</font>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td></tr></table>
		<table border="0" width="100%" cellpadding="0" cellspacing="0">
			<tr>
				' . $bottomLinkTree . '
				<td valign="top" align="right"> <font size="1" class="nav"> ' . $previousNext . '</font></td>
			</tr><tr>
				<td align="left" colspan="2">
					<font size="2">' . implode($menusep, $moderationButtons) . '</font> 
				</td>
			</tr>
			<tr>
				<td align="right" colspan="2"><form action="' . $scripturl . '" method="get">
					<font size="1">' . $txt[160] . ':</font>' . $selecthtml . '</form>
				</td>
			</tr>
		</table>';

	footer();
	obExit();
}
?>