<?php
/*****************************************************************************/
/* MergeThreads.php                                                          */
/*****************************************************************************/
/* YaBB SE: Yet another Bulletin Board Splinter Edition                      */
/* Open-Source Project inspired by Zef Hemel (zef@zefhemel.com)              */
/* Software Version:           YaBB SE 1.5.1                                 */
/* Software by:                The YaBB SE Development Team                  */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Copyright 2001-2003 by:     http://www.lewismedia.com (Lewis Media)       */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/* Inspired and Ported From:   http://www.yabbforum.com                      */
/*****************************************************************************/
/* This program is free software; you may redistribute it and/or modify it   */
/* under the terms of the provided license as published by Lewis Media.      */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the provided    */
/* license for more information.                                             */
/*                                                                           */
/* See license.txt for details of the YaBB SE license. The latest version    */
/* of this license can be found at the distributor's site seen above.        */
/*****************************************************************************/
/* Original module by Mach8                                                  */
/*****************************************************************************/

$mergethreadsphpver = 'YaBB SE 1.5.1';

function MergeThreads()
{
	global $username, $yytitle, $settings, $txt, $board, $maxdisplay, $start, $view, $pageindex;
	global $color, $threadid, $ubbcjspath, $db_prefix, $from, $sc, $scripturl;
	global $modSettings, $scripturl, $img, $targetboard, $moderators;

	if (!(in_array($username, $moderators) || $settings[7] == 'Administrator' || $settings[7] == 'Global Moderator'))
		fatal_error($txt['yse262']);

	$targetboard = ($targetboard > 0  && is_numeric($targetboard) ? $targetboard : $board);

	$request = mysql_query("
		SELECT COUNT(*)
		FROM {$db_prefix}topics
		WHERE ID_BOARD=$targetboard") or database_error(__FILE__, __LINE__);
	list ($topiccount) = mysql_fetch_row($request);

	// Make sure the starting place makes sense.
	$maxindex = ($view == 'all' ? $topiccount : $maxdisplay);
	if (!isset($start) || $start < 0)
		$start = 0;
	if ($start > $topiccount)
		$start = ($topiccount % $maxindex) * $maxindex;

	$start = (int) ($start / $maxindex) * $maxindex;

	// Construct the page links for this board.
	if ($modSettings['compactTopicPagesEnable'] == '0')
	{
		$pageindex .= $start == 0 ? ' ' : '<a href="' . $scripturl . '?board=' . $targetboard . ';action=mergethreads;start=' . ($start - $maxindex) . ';from=' . $from . '">&#171;</a> ';
		$tmpa = 1;
		for ($counter = 0; $counter < $topiccount; $counter += $maxindex)
		{
			$pageindex .= $start == $counter ? '<b>' . $tmpa . '</b> ' : '<a href="' . $scripturl . '?board=' . $targetboard . ';action=mergethreads;start=' . $counter . ';from=' . $from . '">' . $tmpa . '</a> ';
			++$tmpa;
		}
		$tmpa = ($start + $maxindex) > $topiccount ? $topiccount : $start + $maxindex;
		if ($start != $counter - $topiccount)
			$pageindex .= $tmpa > $counter - $maxindex ? ' ' : '<a href="' . $scripturl . '?board=' . $targetboard . ';action=mergethreads;start=' . $tmpa . ';from=' . $from . '">&#187;</a>';
	}
	else
	{
		if (($modSettings['compactTopicPagesContiguous'] % 2) == 1)	//1,3,5,...
			$PageContiguous = (int) ($modSettings['compactTopicPagesContiguous'] - 1) / 2;
		else
			$PageContiguous = (int) $modSettings['compactTopicPagesContiguous'] / 2;

		if ($start > $maxindex * $PageContiguous)	// first
			$pageindex .= '<a class="navPages" href="' . $scripturl . '?board=' . $targetboard . ';action=mergethreads;from=' . $from . '">1</a> ';
		if ($start > $maxindex * ($PageContiguous + 1))	// ...
			$pageindex .= '<b> ... </b>';

		for ($nCont = $PageContiguous; $nCont >= 1; $nCont--)	// 1 & 2 before
			if ($start >= $maxindex * $nCont)
			{
				$tmpStart = $start - $maxindex * $nCont;
				$pageindex.= '<a class="navPages" href="' . $scripturl . '?board=' . $targetboard . ';action=mergethreads;start=' . $tmpStart . ';from=' . $from . '">' . ($tmpStart / $maxindex + 1) . '</a> ';
			}

		$pageindex .= ' [<b>' . ($start / $maxindex + 1) . '</b>] ';

		$tmpMaxPages = (int) (($topiccount - 1) / $maxindex) * $maxindex;	// 1 & 2 after
		for ($nCont = 1; $nCont <= $PageContiguous; $nCont++)
			if ($start + $maxindex * $nCont <= $tmpMaxPages)
			{
				$tmpStart = $start + $maxindex * $nCont;
				$pageindex .= '<a class="navPages" href="' . $scripturl . '?board=' . $targetboard . ';action=mergethreads;start=' . $tmpStart . ';from=' . $from . '">' . ($tmpStart / $maxindex + 1) . '</a> ';
			}

		if ($start + $maxindex * ($PageContiguous + 1) < $tmpMaxPages)	// ...
			$pageindex .= '<b> ... </b>';

		if ($start + $maxindex * $PageContiguous < $tmpMaxPages)	 // last
			$pageindex .= '<a class="navPages" href="' . $scripturl . '?board=' . $targetboard . ';action=mergethreads;start=' . $tmpMaxPages . ';from=' . $from . '">' . ($tmpMaxPages / $maxindex + 1) . '</a> ';
	}

	$request = mysql_query("
		SELECT m.subject
		FROM {$db_prefix}messages AS m, {$db_prefix}topics AS t
		WHERE m.ID_MSG=t.ID_FIRST_MSG AND t.ID_TOPIC=$from
	LIMIT 1") or database_error(__FILE__, __LINE__);
	list($subject) = mysql_fetch_row($request);

	$yytitle = $txt['yse252'];
	template_header();

	echo '
		<script language="JavaScript1.2" type="text/javascript"><!--
			function DoConfirm(message, url) {
				if (confirm(message)) location.href = url;
			}
		//--></script>
		<form action="' . $scripturl . '?action=mergethreads;from=' . $from . ';board=' . $board . ';" method="post">
			<table border="0" width="400" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" cellpadding="4" align="center">
				<tr>
					<td class="titlebg" bgcolor="' . $color['titlebg'] . '"><font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt['yse252'] . '</b></font></td>
				</tr>
				<tr>
					<td class="windowbg" bgcolor="' . $color['windowbg'] . '">' . $txt['yse276'] . '</td>
				</tr>
				<tr>
					<td colspan="2" class="catbg" bgcolor="' . $color['catbg'] . '">
						<table width="100%" cellpadding="0" cellspacing="0" boarder="0"><tr>
							<td><font size="2"><b>' . $txt[139] . ':</b> ' . $pageindex . '</font></td>
						</tr></table>
					</td>
				</tr>
				<tr>
					<td class="windowbg" bgcolor="' . $color['windowbg'] . '" valign="middle" align="center">
						<table vorder="0">
							<tr>
								<td align="right"><br /><b>' . str_replace(' ', '&nbsp;', $txt['yse266']) . '</b> <br /></td>
								<td align="left"><input type="hidden" name="from" value="' . $from . '" /><br />' . $subject . '</td>
							</tr><tr>
								<td align="right"><br /><b>' . str_replace(' ', '&nbsp;', $txt['yse267']) . '</b></td>
								<td align="left">
									<br />
									<select name="targetboard">';

	$condition = $settings[7] == 'Administrator' || $settings[7] == 'Global Moderator' ? '' : "
			AND (FIND_IN_SET('$settings[7]', c.memberGroups) != 0 || c.memberGroups='')";
	$request = mysql_query("
		SELECT b.ID_BOARD, b.name AS bName, c.name AS cName
		FROM {$db_prefix}boards AS b, {$db_prefix}categories AS c
		WHERE b.ID_CAT=c.ID_CAT$condition
		ORDER BY c.catOrder, b.boardOrder;") or database_error(__FILE__, __LINE__);
	while ($row = mysql_fetch_array($request))
		echo '
										<option value="' . $row['ID_BOARD'] . '" ' . ($row['ID_BOARD'] == $targetboard ? 'selected="selected"' : '') . '>' . $row['cName'] . ' - ' . $row['bName'] . '</option>';

	echo '
									</select>&nbsp;<input type="submit" value="' . $txt[462] . '" />
								</td>
							</tr><tr>
								<td align="right" valign="top"><br /><b>' .  $txt['yse269'] . '</b></td>
								<td align="left" style="white-space:nowrap">
									<br />
									<table>';
	$request = mysql_query("
		SELECT t.ID_TOPIC, m.subject, m.posterName, m.ID_MEMBER, mem.realName, mem.memberName
		FROM {$db_prefix}topics AS t, {$db_prefix}messages AS m, {$db_prefix}messages AS m2
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER=m.ID_MEMBER)
		WHERE m.ID_MSG=t.ID_FIRST_MSG
			AND m2.ID_MSG=t.ID_LAST_MSG
			AND t.ID_BOARD=$targetboard
			AND t.ID_TOPIC<>$from
		ORDER BY " . ($modSettings['enableStickyTopics'] == '1' ? 't.isSticky DESC, ' : '') . "m2.posterTime DESC
		LIMIT $start, $maxindex") or database_error(__FILE__, __LINE__);
	while ($row = mysql_fetch_array($request))
	{
		$member = ($row['ID_MEMBER'] == -1 ? $row['posterName'] : "<a href=\"$scripturl?action=viewprofile;user=" . urlencode($row['memberName']) . "\" target=\"_blank\">$row[realName]</a>");
		echo "
										<tr>
											<td valign=\"center\">
												<a href=\"JavaScript:DoConfirm('$txt[yse274] \\'" . addslashes($subject) . "\\' $txt[yse275] \\'" . addslashes($row['subject']) . "\\'?', '$scripturl?board=$board;action=mergethreads2;from=$from;to=$row[ID_TOPIC];sesc=$sc');\">$img[merge_threads]</a>&nbsp;
											</td>
											<td valign=\"center\" style=\"white-space:nowrap\">
												<a href=\"$scripturl?board=$targetboard;action=display;threadid=$row[ID_TOPIC];\" target=\"_blank\">$row[subject]</a> $txt[109] $member
											</td>
										</tr>";
	}
	echo '
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td colspan="2" class="catbg" bgcolor="' . $color['catbg'] . '">
						<table width="100%" cellpadding="0" cellspacing="0" boarder="0"><tr>
							<td><font size="2"><b>' . $txt[139] . ':</b> ' . $pageindex . '</font></td>
						</tr></table>
					</td>
				</tr>
			</table>
		</form>';
	footer();
	obExit();
}

function MergeThreads2()
{
	global $username, $moderators, $settings, $txt, $currentboard, $threadid, $scripturl, $toboard, $yySetLocation;
	global $db_prefix, $reason, $ID_MEMBER, $realemail, $REMOTE_ADDR, $board, $doLimitOne, $postRedirect, $cgi;
	global $from, $to;

	checkSession('get');

	if (!in_array($username,$moderators) && $settings[7] != 'Administrator' && $settings[7] != 'Global Moderator')
		fatal_error($txt['yse262']);

	if (!is_numeric($from) || !is_numeric($to) || $from <= 0 || $to <= 0)
		fatal_error($txt[337]);

	$tresult = mysql_query("SELECT numViews FROM {$db_prefix}topics WHERE ID_TOPIC=$from") or database_error(__FILE__, __LINE__);
	$row = mysql_fetch_array($tresult);
	$fromviews = $row['numViews'];

	$tresult = mysql_query("SELECT numViews FROM {$db_prefix}topics WHERE ID_TOPIC=$to") or database_error(__FILE__, __LINE__);
	$row = mysql_fetch_array($tresult);
	$toviews = $row['numViews'];

	if ($fromviews == '' || $toviews == '')
		fatal_error($txt['yse263']);
	$numviews = $fromviews + $toviews;

	$tresult = mysql_query("SELECT posterTime, ID_MSG FROM {$db_prefix}messages WHERE ID_TOPIC=$from ORDER BY posterTime DESC LIMIT 1") or database_error(__FILE__, __LINE__);
	$row = mysql_fetch_array($tresult);
	$lastpostfrom = $row['posterTime'];
	$lastpostfmsg = $row['ID_MSG'];

	$tresult = mysql_query("SELECT posterTime, ID_MSG FROM {$db_prefix}messages WHERE ID_TOPIC=$to ORDER BY posterTime DESC LIMIT 1") or database_error(__FILE__, __LINE__);
	$row = mysql_fetch_array($tresult);
	$lastpostto = $row['posterTime'];
	$lastposttmsg = $row['ID_MSG'];

	if ($lastpostfrom > $lastpostto)
		$tresult = mysql_query("UPDATE {$db_prefix}topics SET ID_LAST_MSG=$lastpostfmsg WHERE ID_TOPIC=$to") or database_error(__FILE__, __LINE__);

	$tresult = mysql_query("SELECT posterTime, ID_MSG FROM {$db_prefix}messages WHERE ID_TOPIC=$from ORDER BY posterTime ASC LIMIT 1") or database_error(__FILE__, __LINE__);
	$row = mysql_fetch_array($tresult);
	$firstpostfrom = $row['posterTime'];
	$firstpostfmsg = $row['ID_MSG'];

	$tresult = mysql_query("SELECT posterTime, ID_MSG FROM {$db_prefix}messages WHERE ID_TOPIC=$to ORDER BY posterTime ASC LIMIT 1") or database_error(__FILE__, __LINE__);
	$row = mysql_fetch_array($tresult);
	$firstpostto = $row['posterTime'];
	$firstposttmsg = $row['ID_MSG'];

	if ($firstpostfrom < $firstpostto)
	{
		$tresult = mysql_query("SELECT ID_MEMBER FROM {$db_prefix}messages WHERE ID_MSG = $firstpostfmsg") or database_error(__FILE__, __LINE__);
		print $firstpostfmsg;
		$row = mysql_fetch_array($tresult);
		$memberid = $row['ID_MEMBER'];
		$tresult = mysql_query("UPDATE {$db_prefix}topics SET ID_FIRST_MSG=$firstpostfmsg, ID_MEMBER_STARTED=$memberid, ID_MEMBER_UPDATED=$memberid WHERE ID_TOPIC=$to") or database_error(__FILE__, __LINE__);
	}

	$tresult = mysql_query("SELECT COUNT(*) AS numReplies FROM {$db_prefix}messages WHERE ID_TOPIC = $from") or database_error(__FILE__, __LINE__);
	$row = mysql_fetch_array($tresult);
	$oldreplies = $row['numReplies'];

	$tresult = mysql_query("UPDATE {$db_prefix}messages SET ID_TOPIC=$to WHERE ID_TOPIC=$from") or database_error(__FILE__, __LINE__);

	$tresult = mysql_query("SELECT COUNT(*) AS numReplies FROM {$db_prefix}messages WHERE ID_TOPIC = $to") or database_error(__FILE__, __LINE__);
	$row = mysql_fetch_array($tresult);
	$replies = $row['numReplies'];
	$replies = $replies - 1;

	$tresult = mysql_query("UPDATE {$db_prefix}topics SET numReplies=$replies,numViews=$numviews WHERE ID_TOPIC=$to") or database_error(__FILE__, __LINE__);

	$request = mysql_query("SELECT ID_BOARD,ID_POLL FROM {$db_prefix}topics WHERE ID_TOPIC=$from") or database_error(__FILE__, __LINE__);
	$row = mysql_fetch_array($request);
	$oldboard = $row['ID_BOARD'];
	$oldpoll = $row['ID_POLL'];

	$request = mysql_query("SELECT ID_BOARD FROM {$db_prefix}topics WHERE ID_TOPIC=$to") or database_error(__FILE__, __LINE__);
	$row = mysql_fetch_array($request);
	$newboard = $row['ID_BOARD'];

	$request = mysql_query("DELETE FROM {$db_prefix}polls WHERE ID_POLL='$oldpoll' LIMIT 1") or database_error(__FILE__, __LINE__);
	$request = mysql_query("UPDATE {$db_prefix}boards SET numTopics=numTopics-1, numPosts=numPosts-$oldreplies WHERE ID_BOARD=$oldboard") or database_error(__FILE__, __LINE__);
	$request = mysql_query("UPDATE {$db_prefix}boards SET numPosts=numPosts+$oldreplies WHERE ID_BOARD=$newboard") or database_error(__FILE__, __LINE__);
	$request = mysql_query("DELETE FROM {$db_prefix}topics WHERE ID_TOPIC=$from") or database_error(__FILE__, __LINE__);
	$request = mysql_query("DELETE FROM {$db_prefix}log_topics WHERE ID_TOPIC=$from") or database_error(__FILE__, __LINE__);

	updateStats('topic');
	updateLastMessage($oldboard);
	updateLastMessage($newboard);

	$yySetLocation = "$cgi;action=mergethreads3;to=$to;targetboard=$newboard";
	redirectexit();
}

function MergeThreads3()
{
	global $yytitle, $cgi, $board, $to, $txt, $color, $targetboard, $scripturl;

	$yytitle = $txt['yse252'];
	template_header();
	echo '
		<table border="0" width="400" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" cellpadding="4" align="center">
			<tr>
				<td class="titlebg" bgcolor="' . $color['titlebg'] . '"><font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt['yse252'] . '</b></font></td>
			</tr><tr>
				<td class="windowbg" bgcolor="' . $color['windowbg'] . '" valign="middle" align="center">
					<font size="2">
						<br />
						' . $txt['yse264'] . '
						<br /><br />
						<a href="' . $cgi . '">' . $txt[101] . '</a><br />
						<a href="' . $scripturl . '?board=' . $targetboard . ';action=display;threadid=' . $to . '">' . $txt['yse265'] . '</a>
					</font>
				</td>
			</tr>
		</table>';
	footer();
	obExit();
}

?>